"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = usePkceHook;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var PLACECAGE_HOST = 'https://www.placecage.com/';
var TYPES = {
  calm: null,
  gray: 'g',
  crazy: 'c',
  gif: 'gif'
};
var DEFAULT_TYPE = 'calm';
var ERROR_BASE = 'Failed to place Nick';

function generateCage(settings) {
  var _settings$type = settings.type,
      type = _settings$type === void 0 ? DEFAULT_TYPE : _settings$type,
      _settings$width = settings.width,
      width = _settings$width === void 0 ? 200 : _settings$width,
      _settings$height = settings.height,
      height = _settings$height === void 0 ? 200 : _settings$height,
      _settings$count = settings.count,
      count = _settings$count === void 0 ? 1 : _settings$count;
  var config = [];

  if (type !== DEFAULT_TYPE && TYPES[type]) {
    config.push(TYPES[type]);
  }

  config.push(width, height);

  if (isNaN(count)) {
    throw new Error("".concat(ERROR_BASE, ": Invalid count ").concat(count));
  }

  return _toConsumableArray(new Array(count)).map(function () {
    return "".concat(PLACECAGE_HOST).concat(config.join('/'));
  });
}

function usePkceHook() {
  var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return generateCage(settings);
}